/* mesurer.c
 Pour mesurer les temps de frappe
 cestok, cestfaux, cestrien, cestlache, cestfini

 jm, avril 1991
 */
# include <stdio.h>

/*
 Importes de xtype.c
 */
extern char * courant;		/* le caractere courant a taper */
extern char * modele;		/* la chaine de caracteres a taper */
extern int detail;		/* le detail a donner au compte rendu */
extern int automatique;		/* a 1 si on fabrique le modele */
				/* parametres pour decider si la touche va */
extern int erreurmax, okmax, okmoymax;
extern fairefichier;		/* si on se constitue une memoire */

char * remodeler();
/*
 Locales
 */
# define NCHARS	256		/* en general */

static int automate = 0;
# define DEPART 0
# define ERREUR 1
# define OK 2


static long premheure;		/* la premiere et la derniere heure */
static long derheure;

struct mesure {
  int nerreur;			/* nombre d'erreurs avant le car */
  int nok;			/* nombre de mesures ok */
  int oktotal, okmin, okmax;	/* total, min et max des mesures ok */
  int npresse;			/* nombre de mesures temps presse */
  int pressetotal, pressemin, pressemax;
  char c;
} mesure[NCHARS];
# define PREMIER (' ' + 1)

/* cestrien  --  la touche n'a pas de traduction ascii (shift) */
void
cestrien(ascii, heure)
     char ascii;
     long heure;
{
  if (automate == DEPART)
    premheure = heure;
  return;			/* c'est une touche sans trad. ascii */
}

/* cestfaux  --  faute de frappe, ne compter qu'une seule erreur pour
   plusieurs frappes erronne'es d'affile'es */
void
cestfaux(ascii, heure)
     char ascii;
     long heure;
{
  if (automate != ERREUR){
    if (automate == DEPART)
      premheure = heure;
    mesure[courant[0]].nerreur += 1;
    automate = ERREUR;
  }
  derheure = heure;
}

/* cestok  --  la bonne touche */
void
cestok(ascii, heure)
     char ascii;
     long heure;
{
  if (automate == OK){
    register struct mesure * m;
    register long temps = heure - derheure;
    m = & mesure[ascii];
    if (m->nok == 0){
      m->nok = 1;
      m->oktotal = temps;
      m->okmin = temps;
      m->okmax = temps;
    } else {
      m->nok += 1;
      m->oktotal += temps;
      if (m->okmin > temps)
	m->okmin = temps;
      else if (m->okmax < temps)
	m->okmax = temps;
    }
  } else {
    if (automate == DEPART)
      premheure = heure;
    automate = OK;
  }
  derheure = heure;
}

/* cestlache  --  une touche est relachee */
void
cestlache(ascii, heure)
     char ascii;
     long heure;
{
  if (ascii != 0){
    register struct mesure * m;
    register long temps = heure - derheure;
    m = & mesure[ascii];
    if (m->npresse == 0){
      m->npresse = 1;
      m->pressetotal = temps;
      m->pressemin = temps;
      m->pressemax = temps;
    } else {
      m->npresse += 1;
      m->pressetotal += temps;
      if (m->pressemin > temps)
	m->pressemin = temps;
      else if (m->pressemax < temps)
	m->pressemax = temps;
    }
  }    
}

/* cestfini  --  au bout du texte, faire les comptes */
char *
cestfini(n)
     int n;
{
  int i;
  register struct mesure * m, * l;
  int toterreur;
 
  if (mesure[1].c == 0)
    for(i = 1; i < NCHARS; i += 1)
      mesure[i].c = i;


  if (automatique == 0 && fairefichier == 0){
    if (n != -1)
      putchar('\n');
				/* imprimer le bilan */
    if (detail > 0){
# ifndef ENGLISH
      fputs("CAR\tNombre\tERREURS", stdout);
      if (detail > 1)
	fputs("\tATTEINDRE\tPRESSER", stdout);
# else
      fputs("CHAR\t# TYPED\t# ERRORS", stdout);
      if (detail > 1)
	fputs("\tREACH\tPRESS", stdout);
# endif
      putchar('\n');

      for(m = &mesure[0], l = m + NCHARS; m < l; m += 1)
	if (m->nok != 0){
	  static ecricar();
	  
	  ecricar(m->c);
	  
	  printf("%d\t", m->npresse);
	  
	  if (m->nerreur != 0)
	    printf("%d", m->nerreur);
	  
	  if (detail > 1){
	    putchar('\t');
	    if (m->nok != 0)
	      printf("%d:%d:%d", m->oktotal / m->nok, m->okmin, m->okmax);
	    else
	      putchar('\t');
	    putchar('\t');
	    
	    if (m->npresse != 0)
	      printf("%d:%d:%d",
		     m->pressetotal / m->npresse, m->pressemin, m->pressemax);
	  }
	  putchar('\n');
	}
    }

    if (detail > -1){
      printf(
# ifndef ENGLISH
	     "%d car%s en %d s.",
# else
	     "%d char%s. in %s s.",
# endif
	     courant - modele, (courant - modele > 1 ? "s" : ""),
	     (derheure - premheure) / 1000);
      if ((derheure - premheure) / 1000 != 0)
	printf(
# ifndef ENGLISH
	       " (%3.3g car/s),",
# else
	       " (%3.3g char/s),",
# endif	       
	       ((float)(courant - modele)) / ((derheure - premheure) / 1000));

      for(toterreur = i = 0; i < NCHARS; i += 1)
	toterreur += mesure[i].nerreur;
      
      printf(
# ifndef ENGLISH
	     " %d erreur%s",
# else
	     " %d error%s",
# endif
	     toterreur, (toterreur > 1 ? "s" : ""));
      if (courant - modele != 0)
	printf(" (%d%%)", (toterreur * 100) / (courant - modele));
      putchar('\n');
    }

  } else if (automatique == 1 || fairefichier == 1){
    char cava[NCHARS + 1], cavapas[NCHARS + 1];
    int icava = 0, icavapas = 0;

    if (n != -1){
      extern char vues[];
      ecrire(vues);
    } else {
/*
 Il y a un probleme pour la mesure du temps, du au fait que
 quand on ne connait que tres peu de caracteres, on a de fortes
 chances de faire des erreurs dessus puisqu'ils reviennent tout
 le temps.
 */
      for(m = &mesure[PREMIER], l = &mesure[NCHARS]; m < l; m += 1){
	if (m->npresse != 0 && (m->nerreur != 0 || m->nok != 0))
	  if (m->nerreur > erreurmax
	      || (m->nok > 0 && m->okmax > okmax)
	      || (m->nok > 0 && (float)m->oktotal / m->nok > okmoymax))
	    cavapas[icavapas++] = m->c;
	  else
	    cava[icava++] = m->c;
	m->npresse = m->nerreur = m->nok = 0;
      }
      cava[icava] = cavapas[icavapas] = 0;
      automate = DEPART;
      remodeler(cava, cavapas);
      return;
    }
  }
  exit(0);
}

# include <ctype.h>
# define when break;case

/* ecricar  --  ecrire un caractere d'une facon comprehensible ;
   ce que je comprend pas, c'est la facon de mettre une \ dans une chaine */
static ecricar(c)
     char c;
{
  switch(c){
  default:
    if (isgraph(c))
      printf("%c\t", c);
    else
      printf("%c%o\t", '\\', c);
  when ' ':
    fputs("' '\t", stdout);
  when '\n':
    printf("'%cn'\t", '\\');
  when '\t':
    printf("'%ct'\t", '\\');
  when '\f':
    printf("'%cf'\t", '\\');
  when '\b':
    printf("'%cb'\t", '\\');
  when '\r':
    printf("'%cr'\t", '\\');
  }
}
