/* options.c
 le traitement des options dans xtype, mai 1991, 

 jm, 22 mai 1991 : ajoute l'option et la ressource keyboard, ote -name
 jm, 27 mai 1991 : ajoute -keyboard qwerty et -keyboard dvorak
 jm, 12 fevrier 1992 : fixe le XGetDefault de la release 5 dans LeDefaut
 */
# include <stdio.h>
# include <ctype.h>
# include "menu.h"

/*
 Les options positionnables avec leurs defaults
 */
char * arggeometrie = 0;	/* la geometrie de l'argument : pas de defau */
char * resgeometrie = "80x24+10+10"; /* la geometrie dans la ressource */
char * police_clavier = "fixed"; /* police de car. pour afficher le clavier*/
char * police_texte = "9x15";	/* police de car. pour le texte modele */
char * nom_couleur_fond = "white";
char * nom_couleur_devant = "black";
char * nom_couleur_bord = "black";
char * nom_couleur_gris = "grey"; /* couleur du texte a taper */
long bord = 2;			/* epaisseur du bord en pixels (2) */
char * nom_ressource = "a.out";
char * nom_programme = "a.out";
char * nom_icone = "a.out";
char * nom_classe = "A.out";

int boldness = 0;		/* epaissir les caracteres grises */

int centremodele = 0;		/* != 1 si on centre le modele */
int audible = 1;		/* faute de frappe :  si on doit sonner */
int visible = 0;		/* faute de frappe : si la fenetre doit flasher */

extern int kbtype;		/* dans clavier.c */
extern struct entree keyboard_type[]; /* dans clavier.c */

	/* en mode automatique, parametres pour decider si la touche va */
int automatique = 0;		/* si le modele se fabrique */
int erreurmax, okmax, okmoymax;

int fairefichier = 0;		/* en modele, faire un fichier auto. */

	/* en mode automatique, pour fabriquer les modeles */
int quoi = 0;			/* 0 : querty, 1 : dvorak */
int nlignes = 2;		/* nbre de lignes ds une sequence */
int ngroupe = 3;		/* nbre de groupes ds une sequence */
int ncars = 4;			/* nbre de cars ds une sequence */

int detail = 0;			/* niveau de detail du compte rendu */
int dudebut = 1;		/* si on prend la nouvelle touche en partant
				   du debut ; sinon on tourne dans la liste
				   des touches a apprendre */

/* options  --  parse argc et argv */
options(ac, av)
     int ac;
     char * av[];
{
  char ** dav;

  if (av[0] != NULL)
    nom_programme = nom_icone = nom_ressource = av[0];
  if ((nom_classe = (char *)malloc(strlen(nom_ressource) + 1)) == NULL){
# ifndef ENGLISH
    fputs("(dans la fonction commencer) plus de me'moire\n", stderr);
# else
    fputs("(in function commencer) no memory\n", stderr);
# endif
    exit(1);
  } else {
    strcpy(nom_classe, nom_ressource);
    if (islower(nom_classe[0]))
      nom_classe[0] = toupper(nom_classe[0]);
    if (nom_classe[0] == 'X' && islower(nom_classe[1]))
      nom_classe[1] = toupper(nom_classe[1]);
  }

  /*
   Lire les ressources
   */
  { char * t;
    static char * LeDefaut();

    if ((t = LeDefaut("geometry")) != 0 || (t = LeDefaut("Geometry")) != 0)
      resgeometrie = t;
    if ((t = LeDefaut("keyboardFont")) != 0 || (t = LeDefaut("font")) != 0
	|| (t = LeDefaut("Font")) != 0)
      police_clavier = t;
    if ((t = LeDefaut("textFont")) != 0 || (t = LeDefaut("font")) != 0
	|| (t = LeDefaut("Font")) != 0)
      police_texte = t;
    if ((t = LeDefaut("background")) != 0)
      nom_couleur_fond = t;
    if ((t = LeDefaut("foreground")) != 0)
      nom_couleur_bord = t;
    if ((t = LeDefaut("borderColor")) != 0)
      nom_couleur_bord = t;
    if ((t = LeDefaut("gray")) != 0)
      nom_couleur_gris = 0;
    if ((t = LeDefaut("borderWidth")) != 0)
      bord = atol(t);
    if ((t = LeDefaut("center")) != 0)
      centremodele = atoi(t);
    if ((t = LeDefaut("visible")) != 0)
      visible = atoi(t);
    if ((t = LeDefaut("audible")) != 0)
      audible = atoi(t);
    if ((t = LeDefaut("automatic")) != 0)
      automatique = atoi(t);
    if ((t = LeDefaut("keyboard")) != 0){
      int i;
      for(i = 0; keyboard_type[i].marque != 0; i += 1)
	if (strcmp(keyboard_type[i].marque, t) == 0){
	  kbtype = keyboard_type[i].code;
	  break;
	}
    }
  }

  for(dav = ++ av; av[0] != 0; av += 1){
    if (av[0][0] == '=')
      arggeometrie = av[0] + 1;
    else if (av[0][0] == '-' || av[0][0] == '+')
      switch(av[0][1]){
      default:
	usage();

# define when	break; case
# define When	else usage(); break; case
      when 'a':
	if (av[0][2] == 'u'){
	  if (filtre(av[0] + 2, "uto")){ /* auto */
	    automatique = 1;
	    centremodele = 1;
	  } else if (filtre(av[0] + 2, "udible")) /* audible */
	    audible = (av[0][0] == '+');
	}
	
      When 'b':
	if ((!strcmp(av[0] + 1, "borderwidth") || filtre(av[0] + 1, "bw"))
	    && av[1] != 0)
	  bord = atol((++av)[0]);
	else if ((filtre(av[0] + 1, "background") || filtre(av[0] + 1, "bg"))
		 && av[1] != 0)
	  nom_couleur_fond = (++ av)[0];
	else if ((!strcmp(av[0] + 1, "bordercolor") || filtre(av[0] + 1, "bc"))
		 && av[1] != 0)
	  nom_couleur_bord = (++ av)[0];
	else if (filtre(av[0] + 1, "boldness") && av[1] != 0)
	  boldness = atoi(av[1]);
	
      When 'c':
        if (filtre(av[0] + 1, "center"))
	  centremodele = (av[0][0] == '+');	       
	
      When 'd':
	if (filtre(av[0] + 1, "dvorak")){
	  quoi = 1;
	  automatique = 1;
	  centremodele = 1;
	} else if (filtre(av[0] + 1, "detail") && av[1] != 0)
	  detail = atoi(av++[1]);
	else if (filtre(av[0] + 1, "display")
		 || (av[0][2] == 0 && av[1] != 0))
	  av += 1;		/* deja traite dans commencer() */
	
      When 'f':
	if ((filtre(av[0] + 1, "font") || filtre(av[0] + 1, "fn"))
	    && av[1] != 0)
	  police_clavier = police_texte = (++ av)[0];
	else if ((filtre(av[0] + 1, "foreground") || filtre(av[0] + 1, "fg"))
		 && av[1] != 0)
	  nom_couleur_devant = (++ av)[0];
	
      When 'g':
	if ((av[0][2] == 0 || filtre(av[0] + 1, "geometry"))
	    && av[1] != 0)
	  arggeometrie = (++ av)[0];
	else if (filtre(av[0] + 1, "gray") && av[1] != 0)
	  nom_couleur_gris = av++[1];

	
      When 'h':
	if (filtre(av[0] + 1, "help")){
	case '?':
	  puts(
# ifndef ENGLISH
"xtype [fichier]\n\
  Le fichier contient un texte modele qu'on doit taper.\n\
  En plus des options habituelles a X, on a : \n\
  -gray name	utilise la couleur name pour les caracteres a griser\n\
  -keyboard name le clavier est celui de la machine name (sun, sony, apollo)\n\
  [-+]center	(ne pas) centrer les lignes modeles\n\
  [-+]audible	(ne pas) sonner la cloche sur les erreurs de frappe\n\
  [-+]visible	(ne pas) flasher la fenetre sur les erreurs de frappe\n\
  -detail n	niveau de detail du compte rendu (entre -1 et 2)\n\
  -textfont fn	utilise la police fn pour afficher le modele\n\
  -keyboardfont fn utilise la police fn pour afficher le clavier\n\
  -init		fabriquer en mode modele un .xtype pour le mode automatique\n\
  -auto		laisser le programme inventer le texte modele\n\
  Quand il invente le texte modele, le programme utilise les parametres :
   -qwerty	inventer pour un clavier qwerty\n\
   -dvorak	   \"      \"         \"    dvorak\n\
   [-+]round	(ne pas) insister sur les touches mal connues\n\
   -pattern l:g:n generer l lignes de g groupes de n caracteres\n\
   -know E:M:N	on connait une touche quand on fait moins de E erreurs,\n\
                  	qu'on l'atteint en moins de M au maximum, et N\n\
                  	en moyenne (M et N en milli secondes)"
# else
"xtype [file]\n\
  where file contains the text to be typed.\n\
  xtype knows most of the standard X options, and  : \n\
  -keyboard name  names the type of the keyboard : sun, sony, apollo\n\
  [-+]center	do not (do) center the lines\n\
  [-+]audible	do not (do) ring the bell on typing errors\n\
  [-+]visible	do not (do) flash the visible bell on typing errors\n\
  -detail n	level of description of the typing speed (between -1 et 2)\n\
  -keyboardfont fn use the font fn to display the keyboard\n\
  -textfont fn	use ther font fn to display the text to be typed\n\
  -init		use the model mode to build a .xtype file for automatic mode\n\
  -auto		let the program build texts to be typed\n\
  When it builds the texts to be typed, xtype uses :
     -qwerty	invent for a qwerty keyboard\n\
     -dvorak	   \"      \"  dvorak   \"\n\
     [-+]round	do not (do) insist that the old keys must be known\n\
     -pattern l:g:n the texts are made of l lines of g groups of n characters\n\
     -know E:M:N	a key is known when one makes less than E errors,\n\
                  	when the key is found in less than M (maximum),\n\
                  	and N (mean), where M and N are milli-seconds)"
# endif
	     );
	  exit(0);
	}

      When 'i':
	if (filtre(av[0] + 1, "init"))
	  fairefichier = 1;
	
      When 'k':
	if (strcmp(av[0] + 1, "keyboardfont") == 0 && av[1] != 0)
	  police_clavier = av++[1];
	else if (strcmp(av[0] + 1, "keyboard") == 0 && av[1] != 0){
	  int i;
	  for(i = 0; keyboard_type[i].marque != 0; i += 1)
	    if (strcmp(av[1], keyboard_type[i].marque) == 0){
	      kbtype = keyboard_type[i].code;
	      av += 1;
	      goto ok;
	    }
	  usage();
	ok:;
	} else if (filtre(av[0] + 1, "know")
		 && av[1] != 0
		 && sscanf(av[1], "%d:%d:%d", &erreurmax, &okmax, &okmoymax) == 3)
	av += 1;
# if 0
      When 'n':
	if (filtre(av[0] + 1, "name") && av[1] != 0)
	  nom_ressource = nom_programme = nom_icone = av[1];
# endif /* 0 */
      When 'p':
	if (filtre(av[0] + 1, "pattern") && av[1] != 0
	    && sscanf(av[1], "%d:%d:%d", &nlignes, &ngroupe, &ncars) == 3)
	  av += 1;
	
      When 'q':
	if (filtre(av[0] + 1, "qwerty")){
	  quoi = 0;
	  automatique = 1;
	  centremodele = 1;
	}
      
      When 'r':
	if (strcmp(av[0] + 1, "round") == 0)
	  dudebut = (av[0][0] != '+');	       

      When 't':
	if (filtre(av[0] + 1, "title") && av[1] != 0)
	  nom_programme = av[1];
	else if (filtre(av[0] + 1, "textfont") && av[1] != 0)
	  police_texte = av++[1];
    
      When 'v':
        if (filtre(av[0] + 1, "visible"))
	  visible = (av[0][0] == '+');
	else
	  usage();
      } else
	* dav ++ = * av;
  }
  * dav = NULL;
}

usage()
{
# ifndef ENGLISH
  fprintf(stderr, "Usage : %s [fichier], ou %s -help\n", nom_programme,
	  nom_programme);
# else
  fprintf(stderr, "Usage : %s [file] or %s -help\n", nom_programme,
	  nom_programme);
# endif
  exit(1);
}

/* filtre  --  chaine est un prefixe d'au moins deux caracteres de modele */
filtre(chaine, modele)
     char * chaine, * modele;
{
  if (* chaine++ != * modele++ || * chaine++ != * modele++)
    return 0;
  while(chaine[0] != 0 && chaine[0] == modele[0])
    chaine += 1, modele += 1;
  return chaine[0] == 0;
}

/* LeDefaut : la doc de XGetDefault est fausse, les args sont inverses */
/* Dans la release 5, la fonction a changee mais la doc est restee la meme */
# ifdef R5
# define	YGETDEFAULT(a, b, c)	(XGetDefault((a), (c), (b)))
# else
# define	YGETDEFAULT(a, b, c)	(XGetDefault((a), (b), (c)))
# endif
static char * LeDefaut(ressource)
     char * ressource;
{
  char * t;
  extern struct _Display * d;	/* c'est 'Display d;' sans inclure Xlib.h */
  extern char * XGetDefault();

  if ((t = XGetDefault(d, ressource, nom_programme)) == NULL
      && (t = XGetDefault(d, ressource, nom_classe)) == NULL
      && (t = XGetDefault(d, nom_programme, ressource)) == NULL
      && (t = XGetDefault(d, nom_programme, nom_classe)) == NULL 
      && islower(ressource[0])){
    char tmp[1024];
    strncpy(tmp, ressource, sizeof tmp);
    tmp[0] = toupper(tmp[0]);
    ((t = XGetDefault(d, tmp, nom_programme)) != NULL
     || (t = XGetDefault(d, tmp, nom_classe)) != NULL);
  }
  return t;
}
