.TH XTYPE 1 "Release 4" "X Version 11"
.SH NAME
xtype \- a typing tutor for X
.SH SYNOPSIS
.B xtype
[-options ...] \fI[filename]\fP
.SH DESCRIPTION
The \fIxtype\fP program is a program to learn typing. It displays an image of
the keyboard and a text. One has to type the text, that is redisplayed
in gray.
.PP
The \fIfilename\fP argument, if given, is taken as the name of the file
containing the text to type. \fIfilename\fP has also an \fIautomatic\fP
mode to generates random sequences of characters.
.SH "OPTIONS"
.PP
\fIxtype\fP accepts the following options:
.TP 4
.B \-help
cause a brief description of the allowable options and 
parameters to be printed on the standard output.
.TP 4
.B \-keyboard \fIname\fP
specifies the type of the display's keyboard : the currently known
keyboards are sun, sony and apollo.
.TP 4
.B \-display \fIdisplay\fP
specifies the name of the X server to used.
.TP 4
.B \-geometry \fIgeometry\fP
specifies the placement and size of the bitmap window on the
screen.
.TP 4
.B \-bw \fInumber\fP
specifies the border width in pixels of the main window.
.TP 4
.B \-fn \fIfont\fP
 specifies the font to be used for the keyboard and
the text
.TP 4
.B \-fn \fIkeyboardfont\fP
 specifies the font to be used for the keyboard.
.TP 4
.B \-fn \fItextfont\fP
 specifies the font to be used for the text
.TP 4
.B \-fg \fIcolor\fP
 specifies the color to be used for the foreground.
.TP 4
.B \-bg \fIcolor\fP
specifies the color to be used for the background.
.TP 4
.B \-gray \fIcolor\fP
specifies the color to be used for characters already typed. On monochrome
displays, these characters are displayed with a texture.
.TP 4
.B \-bd \fIcolor\fP
 specifies the color to be used for the window border.
.TP 4
.B \+center \fI\fP
specifies that the text should be centered. It is the default
in automatic mode.
.TP 4
.B \-audible
 specifies that the audible bell should not be used on typing errors.
.TP 4
.B \+visible
specifies that the contents of the window should be briefly inverted
on typing errors.
.TP 4
.B \-detail \fIn\fP
specifies the precision of the diagnostics to be printed at the end
of the typing session. \fIn\fP can vary from -1 for no diagnostic
to 2 for a full level diagnostic including for each character
the number of times the character has bee typed, the number of typing
errors, the mean, maximum and minimum time needed to reach the key and
the mean, maximum and minimum time during which the key has been
depressed.
.PP
When in automatic mode, \fIxtype\fP generates texts made of
random sequences of characters. The sequences include more keys
when the learned keys are sufficiently well known.
Between typing sessions, the list of known keys is stored in
a file named \fI.xtype\fP.
.PP
\fIXtype\fP use the following options to build
the texts to be typed:
.TP 4
.B \-qwerty \fI\fP
specifies that the characters should be learned for a qwerty
keyboard. This option implies \-auto.
.TP 4
.B \-dvorak \fI\fP
specifies that the characters should be learned as for a dvorak
keyboard. This option implies \-auto.
.TP 4
.B \+round \fI\fP
specifies that the keys are learned in round-robin, instead of
waiting until the first learned keys are well known.
.TP 4
.B \-pattern \fIl:g:n\fP
specifies that the texts should be made of \fIl\fP lines of \fIg\fP
groups of \fIn\fP characters.
.TP 4
.B \-know \fIE:M:N\fP
specifies that a keys should be considered known when, in a text,
one makes less than \fIE\fP errors, find the key in less than
at the maximum \fIM\fP milliseconds, with a mean of \fIN\fP.
.RE
.SH X RESOURCES AND DEFAULTS
.PP
.I Xtype
uses the following resources:
.TP 4
.B background
The window's background color.
The default value is \fIwhite\fP.
.PP
.TP 4
.B foreground
The window's foreground color.
The default value is \fIblack\fP.
.PP
.TP 4
.B gray
The color's used to paint the background of known keys in
automatic mode. On monochrome displays, \fIxtype\fP uses a
pattern of black and white pixels. On color displays, the
default value is \fIgray\fP.
.PP
.TP 4
.B borderColor
The window's border's color.
The default value is \fIblack\fP.
.PP
.TP 4
.B borderWidth
The window's border thickness, in pixels.
The default value is \fItwo\fP.
.PP
.TP 4
.B geometry
The window's size and placement. The window size is expressed
numbers of characters of the font used for the text to be typed
.PP
.TP 4
.B keyboardFont
The font to use for the keyboard. The default is \fIfixed\fP.
.PP
.TP 4
.B textFont
The font to use for the text. The default is \fI8x15\fP.
.PP
.TP 4
.B keyboard
The type of the display's keyboard. The currently known types are
sun, sony and apollo. The default value is sun.
.PP
.TP 4
.B font
The font to use for both the keyboard and the text.
.PP
.TP 4
.B center
An integer value  indicating if the text should be centered (if not zero)
or left aligned (if zero). The default value is \fIzero\fP,
except for automatic mode.
.PP
.TP 4
.B audible
An integer value between 0 and 100 indicating how much of the audible
bell should be heard when typing errors occur. Zero means
\fINo audible bell\fP. Default value is \fI100\fP.
.PP
.TP 4
.B visible
An integer value indicating how many times the window contents should
be inverted to signal typing errors. Default value is \fIzero\fP.
.PP
.TP 4
.B automatic
An integer value indicating if the model text should built by
the program (if not zero) or read from a file (if zero). The default
value is \fIzero\fP.
.SH "SEE ALSO"
X(1)
.SH FILES
.TP 4
.B .xtype contains the list of keys learned and the maximum error
and time to reach parameters of a previous automatic session started
in this directory.
.SH COPYRIGHT
Copyright 1991, Jean M\*'ehat, universit\*'e de Paris 8 Vincennes \*`a
Saint Denis, 2 rue de la Libert\*'e, 93526 Saint Denis Cedex.
